import pygame
from random import randint

# global game jam 2020 entry: random broken devices
# v0 by y-1

# classes
PORTRADIUS=8

class Wire:
  def __init__(self,parent,startX,startY,plugInModule,plugInPort):
    self.parent=parent
    self.x=startX
    self.y=startY
    self.plugModule=Module()
    self.plugModule.becomePlug(plugInModule,plugInPort)
    self.rgb=(randint(20,255),randint(20,255),randint(20,255))
  def draw(self):
    px=self.parent.getFinalX()
    py=self.parent.getFinalY()
    pygame.draw.rect(s,self.rgb,(px+self.x-PORTRADIUS,py-PORTRADIUS+self.y,PORTRADIUS*2,PORTRADIUS*2))
    pygame.draw.line(s,self.rgb,(px+self.x  ,py+self.y  ),(self.plugModule.getFinalX()  ,self.plugModule.getFinalY()  ))
    pygame.draw.line(s,self.rgb,(px+self.x+1,py+self.y  ),(self.plugModule.getFinalX()+1,self.plugModule.getFinalY()  ))
    pygame.draw.line(s,self.rgb,(px+self.x  ,py+self.y+1),(self.plugModule.getFinalX()  ,self.plugModule.getFinalY()+1))

class Port:
  def __init__(self,parent,x,y):
    self.parent=parent
    self.children=[]
    self.x=x
    self.y=y
  def draw(self):
    px=self.parent.getFinalX()
    py=self.parent.getFinalY()
    pygame.draw.rect(s,(0,0,0),(px+self.x-PORTRADIUS,py-PORTRADIUS+self.y,PORTRADIUS*2,PORTRADIUS*2))
    pygame.draw.rect(s,(220,220,220),(px+self.x-PORTRADIUS,py-PORTRADIUS+self.y,PORTRADIUS*2,PORTRADIUS*2),2)

  def isBelow(self,x,y):
    px=self.parent.getFinalX()
    py=self.parent.getFinalY()
    if x>px+self.x-PORTRADIUS and x<px+self.x+PORTRADIUS and y>py+self.y-PORTRADIUS and y<py+self.y+PORTRADIUS:
      return True
    return False

class Module:
  def __init__(self):
    self.parent=None
    self.correctParent=None
    self.correctParentPort=-1
    self.x=0
    self.y=0
    self.xSizeNeg=0
    self.ySizeNeg=0
    self.xSizePos=0
    self.ySizePos=0
    self.rgb=(0,0,0)
    self.wires=[]
    self.ports=[]
  def becomePCB(self,parent,plugInPort,remainingLevels): # parent can be None (then plugInPort is ignored)
    self.parent=parent
    if parent==None:
      self.x=deviceX+20
      self.y=deviceY+20
      self.xSizeNeg=10
      self.ySizeNeg=10
      self.xSizePos=deviceW-20-self.xSizeNeg
      self.ySizePos=deviceH-20-self.ySizeNeg
    else:
      self.correctParent=parent
      self.correctParentPort=plugInPort
      self.link(parent,plugInPort)
      self.xSizeNeg=randint(40,deviceW)
      self.ySizeNeg=randint(40,deviceH)
      self.xSizePos=randint(40,deviceW)
      self.ySizePos=randint(40,deviceH)
      self.xSizeNeg=80 # - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      self.ySizeNeg=80
      self.xSizePos=80
      self.ySizePos=80
    self.rgb=(randint(10,80),randint(10,200),randint(10,80))

    portCount=3
    self.ports=[]
    p=Port(self,randint(-self.xSizeNeg,self.xSizePos),randint(-self.ySizeNeg,self.ySizePos))
    self.ports+=[p]
    p=Port(self,randint(-self.xSizeNeg,self.xSizePos),randint(-self.ySizeNeg,self.ySizePos))
    self.ports+=[p]
    p=Port(self,randint(-self.xSizeNeg,self.xSizePos),randint(-self.ySizeNeg,self.ySizePos))
    self.ports+=[p]

    self.wires=[]
    if parent!=None:
      w=Wire(self,randint(-self.xSizeNeg,self.xSizePos),randint(-self.ySizeNeg,self.ySizePos),parent,randint(0,portCount-1))
      self.wires+=[w]
    w=Wire(self,randint(-self.xSizeNeg,self.xSizePos),randint(-self.ySizeNeg,self.ySizePos),self,randint(0,portCount-1))
    self.wires+=[w]

    if remainingLevels>0:
      m=Module()
      m.becomePCB(self,randint(0,portCount-1),remainingLevels-1)
  def becomePart(self,parent,plugInPort): # parent can be None (then plugInPort is ignored)
    self.parent=parent
    if parent==None:
      self.x=randint(0,w)
      self.y=randint(deviceY+deviceH+20,h)
    else:
      self.correctParent=parent
      self.correctParentPort=plugInPort
      self.link(parent,plugInPort)
    self.xSizeNeg=20
    self.ySizeNeg=10
    self.xSizePos=20
    self.ySizePos=10
    self.rgb=(0,0,0)
  def becomePlug(self,plugInModule,plugInPort):
    self.parent=plugInModule
    self.correctParent=plugInModule
    self.correctParentPort=plugInPort
    self.xSizeNeg=5
    self.ySizeNeg=5
    self.xSizePos=5
    self.ySizePos=5
    self.rgb=(220,220,220)
    self.link(plugInModule,plugInPort)
  def link(self,parent,port):
    self.x=parent.ports[port].x
    self.y=parent.ports[port].y
    self.parent=parent
    parent.ports[port].children+=[self]
  def isBelow(self,x,y):
    px=0
    py=0
    if self.parent!=None:
      px=self.parent.getFinalX()
      py=self.parent.getFinalY()
    if x>px+self.x-self.xSizeNeg and x<px+self.x+self.xSizePos and y>py+self.y-self.ySizeNeg and y<py+self.y+self.ySizePos:
      return True
    return False
  def getFinalX(self):
    result=self.x
    if self.parent!=None:
      result+=self.parent.getFinalX()
    return result
  def getFinalY(self):
    result=self.y
    if self.parent!=None:
      result+=self.parent.getFinalY()
    return result
  def draw(self):
    x=self.x
    y=self.y
    if self.parent!=None:
      x+=self.parent.getFinalX()
      y+=self.parent.getFinalY()
    # self
    pygame.draw.rect(s,self.rgb                                         ,(x-self.xSizeNeg,y-self.ySizeNeg,self.xSizeNeg+self.xSizePos,self.ySizeNeg+self.ySizePos))
    pygame.draw.rect(s,(self.rgb[0]*0.2,self.rgb[1]*0.2,self.rgb[2]*0.2),(x-self.xSizeNeg,y-self.ySizeNeg,self.xSizeNeg+self.xSizePos,self.ySizeNeg+self.ySizePos),2)
    pygame.draw.rect(s,(self.rgb[0]*0.8,self.rgb[1]*0.8,self.rgb[2]*0.8),(x-5,y-5,10,10))
    # ports
    for port in self.ports:
      port.draw()
    # wires
    for wire in self.wires:
      wire.draw()
    # children
    for port in self.ports:
      for c in port.children:
        c.draw()
  def grabModuleBelow(self,x,y):
    result=None
    for port in self.ports:
      for c in port.children:
        cResult=c.grabModuleBelow(x,y)
        if cResult!=None:
          result=cResult
    if result!=None:
      return result
    if self.isBelow(x,y):
      return self
    return None

# init application
pygame.init()
w=800
h=600
s=pygame.display.set_mode((w,h))
pygame.display.set_caption('random broken devices')

# init level
deviceW=400
deviceH=300
deviceX=50
deviceY=50

mainModule=Module()
mainModule.becomePCB(None,-1,10)

freeModules=[]
replacementPart=Module()
replacementPart.becomePart(None,-1)
freeModules+=[replacementPart]
replacementPart=Module()
replacementPart.becomePart(None,-1)
freeModules+=[replacementPart]
replacementPart=Module()
replacementPart.becomePart(None,-1)
freeModules+=[replacementPart]

cover=Module()
cover.x=deviceX
cover.y=deviceY
cover.xSizeNeg=0
cover.ySizeNeg=0
cover.xSizePos=deviceW
cover.ySizePos=deviceH
cover.rgb=(220,220,220)
freeModules+=[cover]


# init mouse
grabFirstFrame=1
grabModule=None
grabModuleX0=0
grabModuleY0=0
grabX0=0
grabY0=0

# main loop
exit=False
while not exit:

  # read input
  mx,my=pygame.mouse.get_pos()
  mc=pygame.mouse.get_pressed()

  # input: drop module
  if mc==(0,0,0):
    grabFirstFrame=1
    grabModule=None

  # input: move module
  if mc!=(0,0,0) and grabModule!=None:
    grabModule.x=grabModuleX0-grabX0+mx
    grabModule.y=grabModuleY0-grabY0+my

  # input: grab new module
  if mc!=(0,0,0) and grabModule==None and grabFirstFrame==1:
    grabFirstFrame=0
    for m in freeModules:
      if m.isBelow(mx,my):
        grabModule=m
        grabModuleX0=grabModule.x
        grabModuleY0=grabModule.y
        grabX0=mx
        grabY0=my
    if grabModule==None:
      grabModule=mainModule.grabModuleBelow(mx,my)
      if grabModule!=None:
        grabModuleX0=grabModule.x
        grabModuleY0=grabModule.y
        grabX0=mx
        grabY0=my

  # background
  s.fill((40,40,40))
  pygame.draw.rect(s,(200,200,200),(deviceX,deviceY,deviceW,deviceH))
  mainModule.draw()

  # draw non-connected modules
  for m in freeModules:
    m.draw()

  # draw cursor
  c=(0,128,0)
  if mc!=(0,0,0):
    c=(255,0,0)
  pygame.draw.line(s,c,(mx, 0),(mx, h))
  pygame.draw.line(s,c,( 0,my),( w,my))

  # ...
  pygame.display.flip()
  for event in pygame.event.get():
    if event.type == pygame.QUIT:
      exit=True

# exit
pygame.quit()

